#!/usr/local/bin/perl -w

#####
#
# Copyright (C) 2002 UNGI
#
# This file is part of UNGI facturier
#
# UNGI Facturier is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# UNGI Facturier is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#####
#
# Visit us!
#
# http://www.ungi.net
# http://ignu.ungi.org
#
#####


#commande.cgi 

=pod
	ecran d'affichage et de gestion des commandes
=cut

#mettre les librairies ds le chemin de perl
BEGIN {
  unshift @INC, '../lib', '../html';
}

#declaration modules utiles
use strict ;
#pour afficher les elem d'un hachage selon leur ordre d'insertion
use Tie::IxHash;
use CGI  qw(:standard);
#use DBI;
use Conf;
use lang::Fr;
use Util;
use UNGI::Commande;

#print header,start_html(-BGCOLOR => "#ffffff");

#traitement para
my @param=param();

#si pas de para, on quitte
if(!@param){
	print redirect("$CGIADR/login.cgi");
	exit(0);
}

#trt de tous les paras : supp espace devant, derriere
#substitute ' et " par \' ou \"
my ($refpara,$ch)=&getParamHash(@param);
my %para = %$refpara;

		
#recuperation des para d'utilisateurs indisepensables
my $login=param("username");
my $type=param("usertype");

#declaration variables
my $idmod = (param('idmod') || 0);
my $supp = my $mod= 0;
my $numcde=0;
my $mess = '';




###############################
#traitement maj table commande
###############################

#modification d'une commande
if(param('valider')){
   $numcde = param('valider');
   #si la commande selectionne existe plus
   if(!(&compte("numcde","commande","numcde = $numcde"))){
      param("toupdate" => $numcde);
      $numcde = 0;
  }
}


#suppression d'une commande
if(param('supp')){	
	$supp=param('supp');	
	$idmod=$supp;
    if(!(&compte("numcde","commande","numcde = $supp"))){
		param("toupdate" => $supp);
		$supp = 0;
	}
}

#editer un commentaire
if(param('editcde')){	
	my $numcde=param('editcde');
    my $commentaire = '';
	#la commande  commenter existe t'elle?
    if(my $existe = &compte("numcde","commande","numcde = $numcde")){
		if(param("save")){
			my $comment = param("commentaires");
			&maj("numcde=$numcde",{'commentaires' => $comment},'commande');
		}
		($commentaire)=&select_une_lig('commentaires','commande',"numcde=$numcde");
	}
	else{
	    $idmod = &select_pcdtbis("numcde","commande","numcde > 0", 'numcde',$numcde);
		$numcde = 0;
	}
    &affichCommentCommande($commentaire,$numcde,$idmod,$type,$login);
	exit(0);
}

#suppression d'une commande et cration de la facture correspondante
if(param('facturer')){
	#la facture aura pour contact = le commercial de la commande
	#et pour responsable, le client de la commande	
	$supp=param('facturer');	
	#verifier que la commande existe
	if(my $existe = &compte("numcde","commande","numcde = $supp")){
		#listedes champs  insere dans nouvelle facture
		my $listechamps = '(numfact,refcde,contact,clientidfact,datefact,responsablecde,';
		$listechamps .= 'echeance, dateecheance)';
		#on recupere les valeurs  insere dans la fature
		my @listeval=&select_une_lig('refcommande,commercial,nomcli,libcde,montcde',
		'commande',"numcde=$supp");
		#le nom du client = responsablecde
		my ($nomclient,$clientnom2) = &select_une_lig('clientnom, clientnom2','client',"clientid=$listeval[2]");
		#print p "nomcli =$nomclient";
		#print p "cli2 =$clientnom2";
		$nomclient =$clientnom2?$clientnom2:$nomclient;
		#les 2 dernieres val recup concerne la lignede facture
		my @listevallig = (pop(@listeval),pop(@listeval),1,$tvaconst/100);
		my $numfact = &max('facture','numfact','numfact >= 1') + 1;
		unshift(@listeval,$numfact) ;
		my $echeance= $defaultpayment;
		my $dateecheance =&calend_sec(&sec_calend(time() + $echeance * 24*3600)) ;
		push(@listeval,&calend_sec(&sec_calend(time())),$nomclient,$echeance,$dateecheance);
		foreach my $val (@listeval){
			$val =~  s/(?<!\\)('|")/\\$1/g;
			$val="'".$val."'";
		}
		my $listeval = "(".join(",",@listeval).")";
		#on insere l'entete de facture
		&insert( $listeval,$listechamps,"facture");

		my $listechampslig = '(prixHT,libartic,qtefacture,tauxTVA,numfact,ligfact)';
		my $ligfact = &max('lig_facture','ligfact','ligfact >= 1') + 1;
		push(@listevallig,$numfact,$ligfact);
		foreach my $val (@listevallig){
			$val =~  s/(?<!\\)('|")/\\$1/g;
			$val="'".$val."'";
		}
		my $listevallig = "(".join(",",@listevallig).")";
		&insert( $listevallig,$listechampslig,"lig_facture");
		&maj_tot($numfact);
		&supp("numcde=$supp","commande");
		print redirect ("$CGIADR/factmodif.cgi?numfact=$numfact&username=$login&usertype=$type");
		exit(0);
	}
	#la commande  facturer existe pas
	else{
		param("toupdate" => $supp);
		$supp = 0;
	}
}

#ajouter ou modifier une commande
if(param('ajouter') || $numcde){
	my $app=$numcde?"mod":"ajout";
	my $ind=$numcde?"m":"f";
	my $datecde;
	my $datefact;
	#ctrl lib
	if(!param("libcde$app")){$mess.="$messlib, ";}
	#if(!param("nomcli$app")){$mess.="$messname, ";}
	if(!param("refcommande$app") || param("refcommande$app") eq $giveorderref){
		$mess.="$messorderref, ";
	}
	#ctrl prixdep
	my $prix=param("montcde$app");
	$prix =~ s/\s+//g;	
	if($prix && !($prix =~ /^[+\-]{0,1}[0-9]+[,.]{0,1}[0-9]*$/)){
		$mess.="$messht, ";
		}
	else{
		$prix =~ s/,/\./;			
		param("montcde$app" => $prix);
		}
		
	#ctrl date	
	#date commande
	my($jourcde,$moiscde,$ancde)= (param("jour$ind"),param("mois$ind"), param("an$ind"));
	if(!(($jourcde && $moiscde &&$ancde) && (my $ok=&verif_date($jourcde, $moiscde, $ancde)))){
		$mess.="$messdateorder, ";			
		}
	else{$datecde=&calend_sec($jourcde,$moiscde,$ancde);}

    my($jourf,$moisf,$anf)= (param("jourr$ind"),param("moisr$ind"), param("anr$ind"));
    #date previsionnelle de facturation
	if(!(($jourf && $moisf &&$anf) && (my $ok=&verif_date($jourf, $moisf, $anf,1)))){
		$mess.="$messdateprevision, ";			
		}
	else{$datefact=&calend_sec($jourf,$moisf,$anf);}
	if (!param("nomcli$app")){$mess .= $messnocustomerselect;}
	if($numcde && $mess){$mod=1;$idmod=$numcde;}
	if($mess){
		foreach my $para (@param){
			if ($para =~ /($app$|$ind$)/){$para{$para} = param($para);}
		}
		if($numcde){
			$para{'numcde'} = $numcde;	
			#param("toupdate" => $numcde);		
		}
	}	
	if(!$mess){		
		$numcde=$numcde?$numcde:&max('commande', 'numcde') + 1;
		$idmod=$numcde;		
		my %hash;
		$hash{'datecde'} = $datecde;
		$hash{'datefact'} = $datefact;
		my @listechamps=('numcde','datecde','datefact');
		my @listeval =($numcde,$datecde,$datefact);
		foreach my $champs(@param){
			if($champs =~ /($app)$/){
				my $val=param($champs);
				push(@listeval,$val);
				$champs =~ s/$1//;
				push(@listechamps,$champs);
				$hash{$champs}= $val;
				}
			}		
		foreach my $val (@listeval){
				$val="'".$val."'";
			}
		my $listeval = "(".join(",",@listeval).")";		
		my $listechamps = "(".join(",",@listechamps).")";
		if($app eq "ajout"){	
			&insert($listeval,$listechamps,'commande');
			$mess="$messajcdeok";
			param("toupdate" => $numcde);
			#envoi d'un mail pour signifier la cde
			if($mail){			    					
				my $nomcli=param("nomcliajout");				
				($nomcli) =&select_une_lig('clientnom','client',"clientid = $nomcli");					
				my $messmail = &MakeMail(param("commercialajout"),$nomcli,$jourcde,$moiscde,$ancde,
				   param("chefprojetajout"),$prix,param('libcdeajout'));																	
			    &envoiMail($mail,$messmail) ; 
			}
		}
		#verrifier que la commande existe avnat de la modifier
		elsif(&select_une_lig("numcde","commande","numcde = $numcde")){
			$mess = $messmodcdeok;
			&maj("numcde = $numcde",\%hash,"commande");
		}					
	}
	
}

if(param('toupdate')){
	#$mod=1;
	#print p "dans mod";
	$idmod = $mod = $para{"toupdate"} = param('toupdate');
	#print p "dans param(update) mod = $mod";
}

if($idmod){
	param("suivant.x" => 10);
=pod
	if(!(&compte("numcde","commande","numcde = $idmod"))){
        $para{'toupdate'} = $idmod ;
        param('toupdate' => $idmod);
	    $idmod = &select_pcdtbis("numcde","commande","numcde > 0", 'numcde',$idmod);
		$mod = 0;
	}
=cut
}



##########################
#preparation des listes
##########################

#pour la liste des noms de client
#my $liste_champs= "clientnom,clientnom2, clientville, clientcp";
my $liste_champs= "clientnom, clientville, clientcp";
my (%tabcli, %tabcliajout);
tie %tabcli,"Tie::IxHash";
tie %tabcliajout,"Tie::IxHash";
$tabcli{$all}=$all;
%tabcli= (%tabcli,&liste("client", "clientid",$liste_champs,"statut='$libclient'","clientnom"));
$tabcliajout{"0"} = $messchoicecustomer;
%tabcliajout= (%tabcliajout,&liste("client", "clientid",$liste_champs,"statut='$libclient'","clientnom"));


#listes des tri
my %tab = ();
tie %tab,"Tie::IxHash";
%tab = ("numcde",$idordersort,"refcommande",$orderreferencesort, "libcde", $wordsort,  
"datecde", $orderdate,"commercial",$namecommercial,
"chefprojet",$nameleadproject,"montcde", $total);

#liste des commerciaux
my $cond = "userrole = 'commercial' or userrole = 'admin'";
my (%tabcommercial,%tabcommercialajout);
tie %tabcommercial,"Tie::IxHash";
tie %tabcommercialajout,"Tie::IxHash";
$tabcommercial{$all}=$all;
$tabcommercialajout{$nobody}=$tabcommercial{$nobody}= $nobody;
$tabcommercialajout{$boamp}=$tabcommercial{$boamp}= $boamp;
%tabcommercial=(%tabcommercial,&liste("utilisateur","nomcomplet","nomcomplet", $cond,"nomcomplet"));
%tabcommercialajout=(%tabcommercialajout,&liste("utilisateur","nomcomplet","nomcomplet", $cond,"nomcomplet"));

#liste des chefs de projets
$cond = "userrole = 'chefprojet' or userrole = 'admin'";
my (%tabchef,%tabchefajout);
tie %tabchef,"Tie::IxHash";
tie %tabchefajout,"Tie::IxHash";
$tabchef{$all}=$all;
$tabchefajout{$nobody}=$tabchef{$nobody}=$nobody;
$tabchefajout{$chefprojetencours}=$tabchef{$chefprojetencours}=$chefprojetencours;
%tabchefajout=(%tabchefajout,&liste("utilisateur","nomcomplet","nomcomplet", $cond,"nomcomplet"));
%tabchef=(%tabchef,&liste("utilisateur","nomcomplet","nomcomplet", $cond,"nomcomplet"));




################################	
#recuperation des paras de tri
################################

my $som = 0;
my $numcdetri=param("numcdetri");
my $montcdetri=param("montcdetri");
my $refcommandetri=param("refcommandetri");
my $nomclitri = param("nomclitri")?param("nomclitri"):$all;
$para{"nomclitri"} =$nomclitri;
#recherche sur le nom du client (clientnom), de type comme
my $nomlettreclitri = param("nomclilettretri");
my $libcdetri= param("libcdetri");
my $commercialtri=param("commercialtri") ? param("commercialtri"):$all;
$para{"commercialtri"} = $commercialtri;
my $chefprojettri=param("chefprojettri") ? param("chefprojettri"):$all;
$para{"chefprojettri"} =$chefprojettri;
my $antri= param("antri"); my $moistri = param("moistri"); my $jourtri= param("jourtri");

my $nb=param("nbligtri")?param("nbligtri"):$nblig;
my $order=param("tri")?param("tri"):"numcde";
$para{"tri"} =$order;
my ($orderpcd, $ordersuiv)=(param("pcdt"),param("suiv"));
my $inddeb = 0;


#############################
#construction liste commandes
#############################

#preparation ligne sql
my $listechamps = "numcde,refcommande, libcde, commercial, chefprojet,clientnom,"; 
$listechamps .= "datecde, montcde,nomcli,commentaires,datefact ";
my $table = "commande,client";
$cond = "commande.nomcli = client.clientid";

#traitement des para passes pour les tri

if ($numcdetri){
	    my @numcdetri = split (/\D+/,$numcdetri);		
		if(@numcdetri){
		  $cond.= " and (";
    	  foreach my $elem (@numcdetri){$cond.= " numcde like '$elem' or";}
    	  $cond =~ s/or$//;
    	  $cond .= ")";			  
	   }
}

if ($refcommandetri){
		$cond.= " and refcommande like '%$refcommandetri%'";
	}
	
if ($montcdetri){
	$montcdetri=~ s/,/\./;
	$montcdetri =~ s/\..*//;
	my $montcdetribis=$montcdetri.".%";
	$cond.= " and (montcde like '$montcdetri' or montcde like '$montcdetribis')";
}

if($commercialtri ne $all){	
	$cond.= " and commercial like '$commercialtri'";	 	
}
	
if($chefprojettri ne $all){	
	$cond.= " and chefprojet like '$chefprojettri'";		
}
	
if($nomclitri ne $all){$cond.= " and nomcli=$nomclitri";}

#pour une recherche de type comme sur le nom
if($nomlettreclitri){
   my $nomlettreclitribis = "%".$nomlettreclitri."%";
   my @liste = &listenum("clientid","client","clientnom like '$nomlettreclitribis'","clientid");
   @liste = (@liste) ? @liste : (0);
   my $condbis = "(";
   foreach my $val (@liste){
      $condbis .= "nomcli = $val or ";
   }
   $condbis =~ s/or\s*$/ /;
   $condbis .= ")";
   $cond .= " and $condbis ";
}
			
if($antri || $moistri || $jourtri){
	my $ch=&date_tri($antri,$moistri,$jourtri, "datecde","commande");	
	$cond.=$ch;
}

if($libcdetri){
	my $libcdetribis = "%".$libcdetri."%";
	$cond.= " and libcde like '$libcdetribis'";		
}


#verifier que idmod question possedent les para de tri, sinon on enleve les criteres de tri
#$listechamps,$table,$cond
if($idmod){
#verifier que la cde idmod existe
    if(!(&compte("numcde","commande","numcde = $idmod"))){
        $para{'toupdate'} = $idmod ;
        param('toupdate' => $idmod);
	    $idmod = &select_pcdtbis($listechamps,$table,$cond,"numcde",$idmod);
		$mod = 0;
		$order =  $para{"tri"} = "numcde";
	}
	my $lig;		
	my $condbis=$cond. " and numcde=$idmod";
	if(!(($lig)=&select_une_lig("numcde",$table,$condbis))){
		#print p "dans modif selection";
		$cond="commande.nomcli = client.clientid";	
		foreach my $clef (keys %para){
			if($clef =~ /tri$/){$para{$clef}='';}
		}	
	}	
}

if($supp){
		$idmod=&select_pcdt($listechamps,$table,$cond,$order,$supp);
		#print p "idmod= $idmod";
		&supp("numcde=$supp","commande");
		$mess = $messmodsuppok;
}

#recuperation des lignes
my ($reftabquestion,$ordersuivbis);
($reftabquestion,$ordersuivbis)=
 &select_lig($listechamps,$table,$cond,$order,$idmod);
my @table=@$reftabquestion;
my $taille = @table;
#pour afficher partir de la question modifier, ajouter ou pour suivant
$ordersuiv=defined($ordersuivbis)?$ordersuivbis:$ordersuiv;

#recuperer numero dans la liste du 1e elem a afficher, du nb de ligne par ecran
#et du 1er elme et du dernier + 1 dans la liste selon ce qui a ete demande et
#deje vu par l'utilisateur
($inddeb,$orderpcd,$ordersuiv,$nb)= &getIndDeb($nb,$idmod,$ordersuiv,$orderpcd,$taille);
$para{"nbligtri"} = $nb;

#calcul somme total des commandes
$som=sprintf("%.2f",&calculsum($reftabquestion,7));

#construction d'un tableau contenant juste les enreg a afficher, formater
my @tabAffich=();
my $toupdate = 0;#pour verifier s'il existe une commande  modifier
for (my $i=$inddeb;$i < ($inddeb + $nb) &&$i<@table;$i++){			
	my @rangee=@{$table[$i]};
	#formatage date cde
	($rangee[11],$rangee[12],$rangee[13])= my @date =&sec_calend($rangee[6]);
	$rangee[6]=join("/",@date);
	#un petit superfuge pour que l'annee ne subisse pas la sep des milliers
	#$rangee[13] = "%%".$rangee[13];
	#formatage date previsionnel facturation
	($rangee[14],$rangee[15],$rangee[16])= my @daterm =&sec_calend($rangee[10]);
	$rangee[10]=join("/",@daterm);	
	#$rangee[16] = "%%".$rangee[16];		
	$rangee[7]=sprintf("%.2f",$rangee[7]);	
	my $memod = 0;

	if ($mod==$rangee[0]){
	   $memod = 1;
	   $toupdate = 1;
	   if(!exists $para{"numcde"}){
	        @para{"numcdemod","refcommandemod", "libcdemod", "commercialmod","chefprojetmod",
	        "clientnommod","datecdemod", "montcdemod","nomclimod","commentairesmod"}
	        = @rangee;
	        @para{"jourm","moism","anm"} = @rangee[11 .. 13];
	        @para{"jourrm","moisrm","anrm"} = @rangee[14 .. 16];
	     }

	}
	my $modif = ($idmod==$rangee[0] && !$mod) ?$idmod:0;
	my $stand = !$modif;
	my $habit = !$memod;	
	$rangee[17] = {"stand" => $stand, "modif" => $modif,"memod" => $memod, "habit" => $habit};			
    push(@tabAffich,\@rangee);
}
#si la commande a modifier n'existe pas et qu'il n'y a pas
#de commande a creer, $para{"toupdate"} est detruit

if(!$toupdate && exists($para{"toupdate"})  && $para{"toupdate"} > 0){
	$para{"toupdate"} = 0;
}

#on va definir les $para inexistants pour eviter les erreurs dans le fichier de log
foreach my $val ('numcdetri','refcommandetri','montcdetri','libcdetri',
'jourtri','moistri','antri','refcommandeajout','libcdeajout','commentairesajout',
'montcdeajout','jourrf','moisrf','anrf'){
	if(!exists $para{$val}){$para{$val} = '';}
}


##########################################
#affichage liste depenses
##########################################
&AffichCommande($type,$login,$orderpcd,$ordersuiv,$nb,$taille,$som,
    \@tabAffich,\%para,\%tab,\%tabcommercial,\%tabcommercialajout,\%tabchef,\%tabchefajout,
    \%tabcli,\%tabcliajout,$mess);

		



			
