#!/usr/local/bin/perl -w

#####
#
# Copyright (C) 2002 UNGI
#
# This file is part of UNGI facturier
#
# UNGI Facturier is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# UNGI Facturier is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#####
#
# Visit us!
#
# http://www.ungi.net
# http://ignu.ungi.org
#
#####


#facture.cgi affiche la liste des factures

=pod
	affiche la liste des factures 	
=cut	
	
#mettre les librairies ds le chemin de perl

BEGIN {
  unshift @INC, '../lib', '../html';	
} 

#declaration modules utiles
use strict ;
#pour afficher les elem d'un hachage selon leur ordre d'insertion
use Tie::IxHash;
use CGI  qw(:standard);
#use DBI;
use Conf;
use lang::Fr;
use Util;
use UNGI::Facture;
 
#print header,start_html(-BGCOLOR => "#ffffff");

#traitement para
my @param=param();

#si pas de para, on quitte
if(!@param){
	print redirect("$CGIADR/login.cgi");
	exit(0);
}

#trt de tous les paras : supp espace devant, derriere
#substitute ' et " par \' ou \"

my ($refpara,$ch)=&getParamHash(@param);
my %para = %$refpara;
		


#declaration variables
	
#recup parametres
my $login=param("username");
my $type=param("usertype");
my $idmod=param('idmod')?param('idmod'):0;
my $supp=0;
my $mess='';

#trt des donnees
#suppression d'une facture
if(param('supp')){
	#$cond,$table
	$idmod=param('supp');
	if (&compte("numfact","facture","numfact = $idmod")){
		$mess = $messfactsupp;
        $supp=$idmod;
	}

}

if(param('envoi')){
	my $envoi=param('envoi');
	$idmod=$envoi;
    if (&compte("numfact","facture","numfact = $envoi")){
		&maj(" numfact = $envoi ",{'envoi',1},'facture');
    }

}

#afficher un commentaire de facture
if(param('commentrelance')){
	$idmod = param('commentrelance');
	my $numfact = 0 ;
    my $commentaire = my $commentairecli = '';
	my $script = param("script");
	#on verifie que la facture  commenter exsite
	if(&compte("numfact","facture","numfact = $idmod")){
		$numfact = $idmod;
		my ($numcli) =&select_une_lig('clientidfact','facture',"numfact = $numfact");
		if(param("save")){
			my $comment = param("commentaires");
			my $commentcli = param("commentairescli");
			&maj("numfact=$numfact",{'commentaires' => $comment},'facture');
			&maj("clientid=$numcli",{'commentcli' => $commentcli},'client');
		}
		 ($commentaire) = &select_une_lig('commentaires','facture',"numfact = $numfact");
		 ($commentairecli) = &select_une_lig('commentcli','client',"clientid = $numcli");
	}
	else{$idmod =&select_pcdtbis("numfact","facture","numfact > 0", 'numfact',$idmod);}
	&affichCommentFacture($commentaire,$commentairecli,$numfact,$idmod,$type,$login,$script);
	exit(0);
}



#pour la mise en valeur des maj
if($idmod){
    #print p "***dans idmod = $idmod";
	param("suivant.x" => 10);
}	



########################
#preparation des listes
#########################

#liste des clients
my $liste_champs= "clientnom, clientville, clientcp";
my %tabcli=();
tie %tabcli,"Tie::IxHash";
$tabcli{$all}=$all;	
%tabcli= (%tabcli,&liste("client", "clientid",$liste_champs,"client.statut = '$libclient'","clientnom"));

#recup l'equiv lettre du statut de facture
my %statfact=();
tie %statfact,"Tie::IxHash";
$statfact{$all}=$all;
%statfact=(%statfact,&init_statfact("$LIBAD/statfact.conf"));

#pour les echeances de paiement
my %echeance =();	
tie %echeance,"Tie::IxHash";
$echeance{$all}=$all;
foreach my $clef (sort keys %dateech){$echeance{$clef} = $dateech{$clef};}
    
#liste de tri par champs
my %tab =  ("numfact", $idbillliste, "clientnom", $name,  
"datefact", $billdate, "totHT",$totalwithouttaxsort, 
 "totTTC", $totalwithtaxsort, "statutfact", $billstatus);
 
#liste des annees comptable
#recup anne en cours comptable et liste annee comptable valable

=pod
my $datemin = &min("facture", "datefact");
my ($ancourscomptable,$refhashcompt) = &getTempComptable($datemin);
my %hashancompttri;
tie %hashancompttri,"Tie::IxHash";
%hashancompttri = ('0' => $nobody, $all => $all, %$refhashcompt); 
=cut

#liste des statuts d'envoi
my %statenvoi=();
tie %statenvoi,"Tie::IxHash";
$statenvoi{$all}=$all;
%statenvoi=($all => $all, 0 => $no, 1 => $yes);

###############################
#construction liste des factures
##############################		

#declaration de variables	
my $somHT=my $somTTC =0;	
#recuperation des para necc au tri
my $order=param("tri")?param("tri"):"numfact";
$para{"tri"} = $order;
my $orderpcd= param("pcdt");
my $ordersuiv=param("suiv");	
my $numfacttri=param("numfacttri");
my $numchequetri =param("numchequetri"); 
#recherche sur l'identifiant = recherche exacte
my $clientidtri=param("clientidtri")?param("clientidtri"):$all;
#recherche sur le nom du client (clientnom), de type comme
my $nomclitri = param("nomclitri");
my $totTTCtri=param("totTTCtri");
my $totHTtri=param("totHTtri");
my $statuttri=param("statuttri")?param("statuttri"):$all;
my $statutenvoitri = defined(param("statutenvoitri")) &&  param("statutenvoitri") =~ /^(0|1)$/ ?param("statutenvoitri"):$all;
my $echeancedatetri=param("echeancedatetri")?param("echeancedatetri"):$all;
my $antri = param("antri"); my $moistri = param("moistri"); my $jourtri = param("jourtri");

my $anrtri = param("anrtri"); my $moisrtri = param("moisrtri"); my  $jourrtri= param("jourrtri");
my $nb=param("nbligtri")?param("nbligtri"):$nblig;
my $chaine = param('chaine');
my $inddeb = 0;
#on force les $para sur une liste deroulante a une valeur
$para{"tri"} = $order;
$para{"clientidtri"} = $clientidtri;
$para{"statuttri"} = $statuttri;
$para{"echeancedatetri"} = $echeancedatetri;
$para{"statutenvoitri"} = $statutenvoitri;


		
#preparation  liste facture  afficher
#					[0]		 [1]		[2]		[3]		[4]		[5]		[6]			
my $listechamps  = "numfact, clientnom,datefact, totHT, totTTC, statutfact,envoi,";
#					[7]			[8]		[9]
$listechamps  .= "dateecheance,remise, clientidfact";
my $table = "facture, client";	
#construction de la condition
my $cond = " facture.clientidfact = client.clientid " ;
if($type eq $customer){
	#$listechamps,$table,$cond
	my ($clientiduser) = &select_une_lig("clientiduser","utilisateur","userlogin = '$login'");
	$cond .= " and clientidfact = $clientiduser";
}

#traitement des para passes pour les tri
if ($numfacttri){
  my @numfacttri = split (/\D+/,$numfacttri);
  if(@numfacttri){	
    $cond .= " and (";
    foreach my $elem (@numfacttri){$cond.= " numfact like '$elem' or";}
    $cond =~ s/or$//;
    $cond .= ")";
  }
}
		
if($clientidtri ne $all){#clientid
	$cond.= " and clientidfact='$clientidtri'";
}


#pour une recherche de type comme sur le nom
if($nomclitri){
   my $nomclitribis = "%".$nomclitri."%";
   my @liste = &listenum("clientid","client","clientnom like '$nomclitribis'","clientid");
   @liste = (@liste) ? @liste : (0);
   my $condbis = "(";
   foreach my $val (@liste){
      $condbis .= "clientidfact = $val or ";
   }
   $condbis =~ s/or\s*$/ /;
   $condbis .= ")";
   $cond .= " and $condbis ";
}

if($echeancedatetri ne $all){#dateecheance
  $cond.= " and echeance ='$echeancedatetri'";
}

if (defined($totTTCtri) && $totTTCtri =~ /\d+/){#rechercher ent et ent.*
	$totTTCtri =~ s/,/\./;
	$totTTCtri =~ s/\..*//;
	my $totTTCtribis=$totTTCtri.".%";
	my $totTTCtrimoins1 = $totTTCtri - 1;
    my $totTTCtriplus1 = $totTTCtri + 1;
	#$cond.= " and (totTTC like '$totTTCtri' or totTTC like '$totTTCtribis' or totTTC like '$totTTCtrimoins1')";
	$cond .= " and (totTTC  between $totTTCtrimoins1 and $totTTCtriplus1) ";
}

if(defined($totHTtri) && $totHTtri =~ /\d+/){#rechercher ent et ent.*
	$totHTtri =~ s/,/\./;
	$totHTtri =~ s/\..*//;
	my $totHTtribis=$totHTtri.".%";
    my $totHTtrimoins1 = $totHTtri - 1;
    my $totHTtriplus1 = $totHTtri + 1;
	#$cond.= " and (totHT like '$totHTtri' or totHT like '$totHTtribis')";
    $cond.= " and (totHT between $totHTtrimoins1 and $totHTtriplus1)";
}

if($statuttri ne $all){
	#si on choisit un statut different de non regle (statut <> 2)
	#on selectionne seulement les factures possedant ce statut
	if($statuttri  != 2){$cond.= " and statutfact=$statuttri ";}
	#sinon si on choisit non regle (statut = 2) on selectionne les
	#fact non regle et les fact relancees (statut > 1)
	else{$cond.= " and statutfact > 1 ";}
}

if($statutenvoitri ne $all){
	$cond.= " and envoi =  $statutenvoitri";
}

if($antri || $moistri || $jourtri){
	my $ch=&date_tri($antri,$moistri,$jourtri, "datefact","facture");	
	$cond.=$ch;
	#print p "ch = $ch";
}

if($anrtri || $moisrtri || $jourrtri){
	my $ch=&date_tri($anrtri,$moisrtri,$jourrtri, "datereglement","facture");	
	$cond.=$ch;
	#print p "ch = $ch";
}


	 
if($numchequetri){
	$cond .= "and numcheque = '$numchequetri'";
}	

	
#verifier que idmod question possedent les para de tri, sinon on enleve les criteres de tri
#$listechamps,$table,$cond
if($idmod){
    #verifier qu'idmod existe pour le trt des selcetions
    #d'objet qui n'existe plus
	if(!(&compte("numfact","facture","numfact = $idmod"))){
	    $para{'notexiste'} = $idmod;
	    $idmod = &select_pcdtbis($listechamps,$table,$cond, "numfact",$idmod);
		$order =  $para{"tri"} = "numfact";
	}
	my $lig;
	my $condbis=$cond. " and numfact=$idmod";
	#print p "cond = $cond";
    #print p "condbis = $condbis";
	if(!(($lig)=&select_une_lig("numfact",$table,$condbis))){
		$cond= " facture.clientidfact = client.clientid " ;
		if($type eq $customer){		
		    my ($clientiduser) = &select_une_lig("clientiduser","utilisateur","userlogin = '$login'");
		    $cond .= " and clientidfact = $clientiduser";
	    }	
		foreach my $clef (keys %para){;
			if($clef =~ /tri$/ ){$para{$clef}='';}
		}
	}
	#print p "cond = $cond";
}



#pour positionner sur la fact pcdt la fact supp, en se basant sur l'id	
if($supp){
		$idmod=&select_pcdt($listechamps,$table,$cond,$order,$supp);
		#print p "idmod= $idmod";
		#supprimer les lignes de factures
		&supp("numfact = $supp",'lig_facture');
		#supp la facture
		&supp("numfact = $supp",'facture');
		#supp les relances associes a la fature
		&supp("numfact = $supp",'relance');	
		if (-f "$FACTUREAD/$supp.pdf"){unlink("$FACTUREAD/$supp.pdf");}
        if (-f "$FACTUREAD/duplicata$supp.pdf"){unlink("$FACTUREAD/duplicata$supp.pdf");}
}
		
my ($reftabquestion,$ordersuivbis);
($reftabquestion,$ordersuivbis)=&select_lig($listechamps,$table,$cond,$order,$idmod);
my @table=@$reftabquestion;
my $taille = @table;
#pour afficher  partir de la question modifier, ajouter ou pour suivant
$ordersuiv=defined($ordersuivbis)?$ordersuivbis:$ordersuiv;

#recuperer numero dans la liste du 1e elem a afficher, du nb de ligne par ecran
#et du 1er elme et du dernier + 1 dans la liste selon ce qui a ete demande et
#deje vu par l'utilisateur

($inddeb,$orderpcd,$ordersuiv,$nb)= &getIndDeb($nb,$idmod,$ordersuiv,$orderpcd,$taille,$chaine,$ch);
$para{"nbligtri"} = $nb;

#print p "nb = $nb";
#print p "ordersuiv = $ordersuiv";

#calcul somme total				
$somHT=sprintf("%.2f",&calculsum($reftabquestion,3));
$somTTC=sprintf("%.2f",&calculsum($reftabquestion,4));
			
#construction d'un tableau contenant juste les enreg a afficher, formater
my @tabAffich=();
for (my $i=$inddeb;$i < ($inddeb + $nb) &&$i<@table;$i++){			
	my @rangee=@{$table[$i]};
	$rangee[5]=$statfact{$rangee[5]};
	my @date=&sec_calend($rangee[2]);
	$rangee[2]=join("/",@date);
	my @dateecheance=&sec_calend($rangee[7]);
	$rangee[7]=join("/",@dateecheance);
	$rangee[3]=$rangee[3]?$rangee[3]:0;
	$rangee[4]=$rangee[4]?$rangee[4]:0;
	$rangee[3]=sprintf("%.2f",$rangee[3]);
	$rangee[4]=sprintf("%.2f",$rangee[4]);
	$rangee[8]=($rangee[8])?sprintf("%.2f%",$rangee[8]):"--"; #remise
	$rangee[6]=$rangee[6]?"oui":"non";
	#cherche s'il existe des lignes a completer						
	#my $comp=&cherchecomp($rangee[0]);
	my $mod = ($idmod==$rangee[0])?$idmod:0;
	my $stand = !$mod;
	my $env = ($rangee[6] eq "oui")? 0 : 1;
	#affichez le bouton mensuel si periodicite <> 0 et periodifait = 0

=pod
	my ($periodicite,$fait) = &select_une_lig("periodicite, periodfait", "facture", "numfact = $rangee[0]");
	my $per = ($periodicite && !$fait ? 1 : 0);
=cut
	#$rangee[8] = {"comp" => $comp, "stand" => $stand, "mod" => $mod ,"env" => $env};
	$rangee[10] = {"stand" => $stand, "mod" => $mod ,"env" => $env};
    push(@tabAffich,\@rangee);
}


#on va definir les $para inexistants pour eviter les erreurs dans le fichier de log
foreach my $val ('numfacttri','nomclitri','jourtri','moistri','antri','jourrtri','moisrtri','anrtri',
'totHTtri','totTTCtri','numchequetri'){
	if(!exists $para{$val}){$para{$val} = '';}
}


########################
#affichage liste facture
########################

&ListeFacture($type,$login,$orderpcd,$ordersuiv,$nb,$taille, $titleconsfact,
               $somHT,$somTTC,$mess, \@tabAffich,
              \%para,\%tabcli,\%statfact,\%echeance,\%tab,\%statenvoi);
			

		
	

	
		
	



