#!/usr/local/bin/perl -w

#####
#
# Copyright (C) 2002 UNGI
#
# This file is part of UNGI facturier
#
# UNGI Facturier is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# UNGI Facturier is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#####
#
# Visit us!
#
# http://www.ungi.net
# http://ignu.ungi.org
#
#####


#regler.cgi pour saisir les renseignements relatifs au rglement d'une facture


=pod
	script pour mettre  regler une facture		
=cut	
	
#mettre les librairies ds le chemin de perl

BEGIN {
  unshift @INC, '../lib', '../html';	
} 

#declaration modules utiles
use strict ;
#pour afficher les elem d'un hachage selon leur ordre d'insertion
use Tie::IxHash;
use CGI  qw(:standard);
#use DBI;
use Conf;
use lang::Fr;
use Util;
use UNGI::Entree;


#print header,start_html(-BGCOLOR => "#ffffff");

#redirection si pas de para
my @param=param();
if(!@param){
	print redirect("$CGIADR/login.cgi");
	exit(0);
}

#trt de tous les paras : supp espace devant, derriere
#substitute ' et " par \' ou \"

my ($refpara,$ch)=&getParamHash(@param);
my %para = %$refpara;


#recup parametres
my $login=param("username");
my $type=param("usertype");
my $numfact=param("numfact");
my $mess='';
$para{"numfact"} = $numfact;

#si $numfact et la facture numfact existe pas, il faut traiter
if($numfact && !&compte("numfact","facture","numfact = $numfact")){
	print redirect("$CGIADR/entrees.cgi?idmod=$numfact&username=$login&usertype=$type&$ch");
	exit(0);
}


#maj facture	
if(param('valider')){	
	my $datereglement=0;	
	my ($jourreg,$moisreg,$anreg)= (param("jourr"),param("moisr"),param("anr")) ;
	if(!(($jourreg && $moisreg &&$anreg) && (my $ok=&verif_date($jourreg, $moisreg, $anreg)))){
		$mess.="$messdatereglement, ";					
	}
	else{
		$datereglement=&calend_sec($jourreg, $moisreg, $anreg);		
	}
			
	my $fraisdeplt=param('fraisdepltmod');
	$fraisdeplt =~ s/\s+//g;
	if ($fraisdeplt && !($fraisdeplt =~ /^[+\-]{0,1}[0-9]+[,.]{0,1}[0-9]*$/)){
	  $mess .="$messfraisdeplt, ";
	  $fraisdeplt=0;		
	}
	else{
	  $fraisdeplt =~ s/,/\./;
	  param('fraisdepltmod' => $fraisdeplt);
	}
	if(!$mess){	  
	  my %hash;
	  $hash{'datereglement'}=$datereglement;
	  $hash{'statutfact'}=1;
      $hash{'envoi'}=1;
	  foreach my $champs(@param){
		if($champs =~ /(mod)$/){
			my $val=param($champs);				
			$champs =~ s/$1//;				
			$hash{$champs}= $val;				
		}
	  }				
	  &maj("numfact = $numfact",\%hash,"facture");
	  &maj_tot($numfact); 
	  my ($datefact)=&select_une_lig("datefact","facture","numfact=$numfact");
	  my (undef,$mois,$an)=&sec_calend($datefact);
	  &majbanque($mois,$an);
	  $mess.="$messmodifok";	
	}
}
	

##############################	
#preparation liste deroulantes
##############################
my %listestatut;
tie %listestatut,"Tie::IxHash";
%listestatut=&init_statfact("$LIBAD/statfact.conf"); 

#pour le mode de paiment
my %paiement =();
tie %paiement,"Tie::IxHash";
$paiement{'0'} = $messchoicepaiment;
foreach my $clef (sort keys %modepaiement){$paiement{$clef} = $modepaiement{$clef};}


####################################
#preparation des donnees a afficher
####################################
	
#selection entete facture
my $listechamps = "clientidfact,clientnom, responsablecde, refcde, datefact, statutfact, ";
$listechamps .= " fraisdeplt, totHT, totTTC, contact, datereglement, banquereglement, numcheque,paiement ";
my $table = " client, facture ";
my $cond = " client.clientid = facture.clientidfact and numfact = $numfact";   
my @ramenechamps=&select_une_lig($listechamps,$table,$cond);
foreach my $clef (@ramenechamps){	
	if($clef){$clef =~ s/"/\&quot;/g;}		
}

#formatage sur 2dec des montants et valorisation du statut
$ramenechamps[6]=sprintf("%.2f",$ramenechamps[6]);
$ramenechamps[7] = sprintf("%.2f",$ramenechamps[7]);
$ramenechamps[8] = sprintf("%.2f",$ramenechamps[8]);    	
$ramenechamps[5]=$listestatut{$ramenechamps[5]};



#############################
#affichage facture
#############################
&majEntree($numfact,$type,$login,\%para,\@ramenechamps,\%paiement, $mess);




	
