#!/usr/local/bin/perl -w

#####
#
# Copyright (C) 2002 UNGI
#
# This file is part of UNGI facturier
#
# UNGI Facturier is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# UNGI Facturier is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#####
#
# Visit us!
#
# http://www.ungi.net
# http://ignu.ungi.org
#
#####


#relance.cgi pour gestion des relances
 
 
=pod        
       liste des relances 
=cut
 
#mettre les librairies ds le chemin de perl

BEGIN {
  unshift @INC, '../lib', '../html';	
} 

#declaration modules utiles
use strict ;
#pour afficher les elem d'un hachage selon leur ordre d'insertion
use Tie::IxHash;
use CGI  qw(:standard);
#use DBI;
use Conf;
use lang::Fr;
use Util;
use UNGI::Relance;


#print header,start_html(-BGCOLOR => "#ffffff");

#recup para
my @param=param();


#si pas de para, on quitte
if(!@param){
	print redirect("$CGIADR/login.cgi");
	exit(0);
}

#trt de tous les paras : supp espace devant, derriere
#substitute ' et " par \' ou \"

my ($refpara,$ch)=&getParamHash(@param);
my %para = %$refpara;

=pod
foreach my $para (%para){
	print "para = $para, val = $para{$para}";
}
=cut

#declaration variables	
#recup parametres
my $login=param("username");
my $type=param("usertype");
my $idmod=param('idmod')?param('idmod'):0;
my $mess='';


####################
#maj des relances
####################

#incrementer les relances
if(param('incrementer')){
       &debug("debut incrementation de facture num : ", param('incrementer'));
       my $numfact= $idmod = param('incrementer');
	   #verifier que la facture  incrementer existe
	   if (&compte("numfact","facture","numfact = $numfact")){
		#verifier que pas dej au max de relance
		my $max =  &compte( "idrelance","relance","numfact= $numfact");
		if($max < $maxrelance && &select_une_lig("numfact","facture","numfact=$numfact")){
			#enregistrer la relance
			my $maxrel=&max("relance","idrelance" ) + 1 ;
			my ($jour, $mois, $an)=&sec_calend(time);
			my $daterelance=&calend_sec($jour, $mois, $an);
			#$liste_val,$liste_champs,$table
			&insert("('$maxrel', '$daterelance',' $numfact')" ,"(idrelance,daterelance,numfact)","relance");
			#maj du statut de la facture
			# $count,$table,$cond
			my $statut = &compte("idrelance","relance","numfact=$numfact") + 2 ;
			#my =$compterelance + 2;
			&maj( "numfact=$numfact",{'statutfact' => $statut},'facture');
      	} 
      }
      &debug("fin incrementation de facture num : ", param('incrementer'));
}

#decrementer les relances
if(param('decrementer')){
       &debug("debut decrementation de facture num : ", param('decrementer'));
       my $numfact= $idmod = param('decrementer');
       #verifier que la facture  incrementer existe
	   if (&compte("numfact","facture","numfact = $numfact")){
		#verifier que pas dej au max de relance
		if(&compte( "idrelance","relance","numfact= $numfact")){
			#recup num relance max de la facture
			#$table,$champs,$cond
			my $idrelance = &max('relance', 'idrelance', "numfact = $numfact");
			#decrementer la relance
			&supp("idrelance = $idrelance","relance");
			#maj du statut de la facture
			my $statut = &compte("idrelance","relance","numfact=$numfact") + 2;
			&maj( "numfact=$numfact",{'statutfact' => $statut},'facture');
		}
       }
	&debug("fin decrementation de facture num : ", param('decrementer'));
}


#edition lettre de relance choisit	
if(param('editunerelance' )){
    &debug("debut editrelance de facture num : ", param('editunerelance'),
	" pour relance num ", param('numrelance'));
	#recup numfacture
	my $numfact = param('editunerelance' );
	#recup numrelance
	my $numrelance = param('numrelance');
	#verifier que la facture existe
	if(!(&compte("numfact","facture","numfact = $numfact"))){
		$para{'notexiste'} = $numfact;
	}
	#verifier qu'il ny a pas moins de relance que la relance demande
	elsif($numrelance > &compte("idrelance","relance","numfact=$numfact")){
        $para{'notexiste'} = $numrelance;
	}
	#recup des champs necc a l'edition de la relance
	my ($reffacture,$reflisterelance)= &getUneRelance($numfact);
	#ne pas editer une relance qui n'existe pas (facture n'existe
	#pas ou moins de relance que le num selectionner
	#my $nbrelance = &compte("idrelance","relance","numfact=$numfact");
    &debug("affichage relance de facture num : ", param('editunerelance'),
    " pour relance num ", param('numrelance'));
	#&editUneRelance($reffacture,$numrelance,$reflisterelance,$nbrelance,\%para);
    &editUneRelance($reffacture,$numrelance,$reflisterelance,\%para,$type,$login,$numfact);
	exit(0);

}

#editer l'ensemble des lettres de relance ou fax de relance
if(param('editrelance') || param('editfaxrelance')){
    &debug("debut edition liste des relances",param('editrelance') || param('editfaxrelance'));
	#pour savoir si on envoi des fax (typerel = fax) ou des lettres (typerel=lettre)
	my $typerel = param('editrelance')?param('editrelance'):param('editfaxrelance');
	#print p "typerel = 	$typerel";
	my @liste = &listenum("numfact","facture","statutfact > 2","numfact");
	my @listrelance = ();
	foreach my $num (@liste){
		my ($reffacture,$reflisterelance,$compte)= &getUneRelance($num);
		push(@listrelance,[$reffacture,$reflisterelance]);
	}
    &debug("debut affichage liste des relances",param('editrelance') || param('editfaxrelance'));
	&editListeRelance(\@listrelance,$typerel);
	exit(0);
}


#pour la mise en valeur des maj
if($idmod){
	param("suivant.x" => 10);
}
	

########################
#preparation des listes
#########################
#recup l'equiv lettre du statut de facture
my %statfact;
tie %statfact,"Tie::IxHash";
%statfact=(%statfact,&init_statfact("$LIBAD/statfact.conf"));

#pour les echeances de paiement
my %echeance;	
tie %echeance,"Tie::IxHash";
$echeance{$all}=$all;
foreach my $clef (sort keys %dateech){$echeance{$clef} = $dateech{$clef};}

#pour la liste des noms de client
my $liste_champs= "clientnom, clientville, clientcp";
my %tabcli;
tie %tabcli,"Tie::IxHash";
$tabcli{$all}=$all;	
%tabcli= (%tabcli,&liste("client", "clientid",$liste_champs,"1","clientnom"));

#liste de tri par champs
my %tab = ();
tie %tab,"Tie::IxHash";
%tab =  ("numfact", $idbillliste, "clientnom", $name,
	"datefact", $billdate,"echeance",$payment,"dateecheance",$dpayment );		

################################################
#preparation de la liste des relances a afficher
################################################

#recuperation des para necc au tri
my $order=param("tri")?param("tri"):"numfact";
my $orderpcd= param("pcdt");
my $ordersuiv=param("suiv");
my $numfacttri=param("numfacttri");
my $clientidtri=param("clientidtri")?param("clientidtri"):$all;
my $echeancedatetri=param("echeancedatetri")?param("echeancedatetri"):$all;

my $chaine = param('chaine');
my $nb=param("nbligtri")?param("nbligtri"):$nblig;
my $somHT =0;
my $dateselect=time();
my $inddeb = 0;
#=pod
$para{"tri"} = $order;
#$para{"numfacttri"} = $numfacttri;
$para{"clientidtri"} = $clientidtri;
$para{"echeancedatetri"} = $echeancedatetri;
#=cut

#preparation  liste facture  afficher
my $listechamps  = "numfact, clientnom,datefact,dateecheance,echeance, totHT, totTTC,clientidfact";
my $table = "facture, client";
#construction de la condition
my $cond = " facture.clientidfact = client.clientid and statutfact > 1 and dateecheance < $dateselect " ;

#trt para de tri
if ($numfacttri){
  my @numfacttri = split (/\D+/,$numfacttri);
  if(@numfacttri){	
    $cond .= " and (";
    foreach my $elem (@numfacttri){$cond.= " numfact like '$elem' or";}
    $cond =~ s/or$//;
    $cond .= ")";
  }
}
	
if($clientidtri ne $all){#clientid
	$cond.= " and clientidfact='$clientidtri'";
}

if($echeancedatetri ne $all){#dateecheance	  
	  $cond.= " and echeance ='$echeancedatetri'";
}

#verifier que idmod question possedent les para de tri, sinon on enleve les criteres de tri
#$listechamps,$table,$cond
if($idmod){
#verifier que la relance correspondant  idmod existe
    if(!(&compte("numfact","facture","numfact = $idmod"))){
		$para{'notexiste'} = $idmod;
	    $idmod = &select_pcdtbis($listechamps,$table,$cond, "numfact",$idmod);
		$order =  $para{"tri"} = "numfact";
	}
	my $lig;
	my $condbis=$cond. " and numfact=$idmod";
	if(!(($lig)=&select_une_lig("numfact",$table,$condbis))){
		$cond= "facture.clientidfact = client.clientid and statutfact > 1 and dateecheance < $dateselect and envoi =1" ;
		foreach my $clef (keys %para){;
			if($clef =~ /tri$/ ){$para{$clef}='';}
		}
	}		
}

my ($reftabquestion,$ordersuivbis);
($reftabquestion,$ordersuivbis)=&select_lig($listechamps,$table,$cond,$order,$idmod);
my @table=@$reftabquestion;
my $taille = @table;

#pour afficher partir de la question modifier, ajouter ou pour suivant
$ordersuiv=defined($ordersuivbis)?$ordersuivbis:$ordersuiv;

#recuperer numero dans la liste du 1e elem a afficher, du nb de ligne par ecran
#et du 1er elme et du dernier + 1 dans la liste selon ce qui a ete demande et
#deje vu par l'utilisateur
($inddeb,$orderpcd,$ordersuiv,$nb)= &getIndDeb($nb,$idmod,$ordersuiv,$orderpcd,$taille,$chaine,$ch);
$para{"nbligtri"} = $nb;
	
#calcul somme total
$somHT=sprintf("%.2f",&calculsum($reftabquestion,5));


#construction d'un tableau contenant juste les enreg a afficher, formater
my @tabAffich=();
for (my $i=$inddeb;$i < ($inddeb + $nb) &&$i<@table;$i++){			
	my @rangee=@{$table[$i]};	
	$rangee[2]=join("/",&sec_calend($rangee[2]));
	$rangee[3]=join("/",&sec_calend($rangee[3]));
	$rangee[5]=$rangee[5]?$rangee[5]:0;
	$rangee[5]=sprintf("%.2f",$rangee[5]);
    $rangee[6]=$rangee[6]?$rangee[6]:0;
	$rangee[6]=sprintf("%.2f",$rangee[6]);
	$rangee[8]=&compte( "idrelance","relance","numfact= '$rangee[0]'");
	if($rangee[4]==-1){$rangee[4] = $dateech{"-1"};}
    if($rangee[8]){
    	  my %relance = ();
    	  tie %relance,"Tie::IxHash";
          my $daterelance=&max( "relance","daterelance","numfact=$rangee[0] ");          
          $rangee[9]=join('/', &sec_calend($daterelance));
          for(my $i=1;$i <= $rangee[8];$i++){
          	$relance{$i} = $statfact{$i + 2};
          }
          $rangee[10] = [\%relance,$rangee[8],"numrelance"];
    } 
    else{$rangee[9]="pas de relance";}
	my $mod = ($idmod==$rangee[0])?$idmod:0;
	my $stand = !$mod;
	my $dec = $rangee[8];
	my $inc = ($rangee[8] == $maxrelance) ? 0 : 1;
	my $nodec = !$dec;
	$rangee[12] = {"stand" => $stand, "mod" => $mod, "inc" => $inc, "dec" => $dec, "nodec" => $nodec};
    push(@tabAffich,\@rangee);
}

#on va definir les $para inexistants pour eviter les erreurs dans le fichier de log
foreach my $val ('numfacttri'){
	if(!exists $para{$val}){$para{$val} = '';}
}


########################
#affichage liste relances
########################
&debug ("appel affichage liste relances,fonction &ListeRelance");
&ListeRelance($type,$login,$orderpcd,$ordersuiv,$nb,$taille,
               $somHT,$mess, \@tabAffich,
              \%para,\%tabcli,\%echeance,\%tab);
			

	
	


	
		



