#!/usr/local/bin/perl -w

#####
#
# Copyright (C) 2002 UNGI
#
# This file is part of UNGI facturier
#
# UNGI Facturier is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# UNGI Facturier is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#####
#
# Visit us!
#
# http://www.ungi.net
# http://ignu.ungi.org
#
#####


#statistiques.cgi 
=pod
	ecran des statistiques=
		liste des ca (somme factures HT pour un mois)
		liste des depenses pour un mois(HT)
		liste des benefices(factures - depenses) pour un mois
		liste entres(factures reglees HT pour un mois)
		liste des banques(banque mois precedent + entres - depenses) pour un mois
		moyenne de chacune de ces valeurs
	statistiques.html,
	 ligstat.html, entete.html 
=cut


BEGIN {
  unshift @INC, '../lib', '../html';
}

#declaration modules utiles
use strict ;
#pour afficher les elem d'un hachage selon leur ordre d'insertion
use Tie::IxHash;
use CGI  qw(:standard);
#use DBI;
use Conf;
use lang::Fr;
use Util;
use UNGI::Statistique;

#print header,start_html(-BGCOLOR => "#ffffff");

#traitement para
my @param=param();

#si pas de para, on quitte
if(!@param){
	print redirect("$CGIADR/login.cgi");
	exit(0);
}

#trt de tous les paras : supp espace devant, derriere
#substitute ' et " par \' ou \"

my ($refpara,$ch)=&getParamHash(@param);
my %para = %$refpara;
		

#recuperation des para d'utilisateurs indisepensables
my $login=param("username");
my $type=param("usertype");	

#maj de la table banque
&majbanque();

##################################
#preparation liste deroulantes
###################################
#on recupere la plus petite date des factures /depenses
my ($moismin,$anmin) = &getDatemin();
#on recupere le mois et l'annee en cours
my(undef,$moiscour,$ancour)=&sec_calend(time);
&debug("datencour = $moiscour : $ancour ");

#l'annee en cours comptable et liste des annes
my ($ancourscomptable,$refhashcompt) = &getTempComptable($moismin,$anmin);





 
#liste des mois comptables
my @moiscomptable = ();
for(my $i = $moiscomptable,my $j=0; $i < $moiscomptable + 12 ; $i++,$j++){
	$moiscomptable[$j] = ($i <= 12) ? $i : $i - 12;

}

&debug ("liste des mois compables=join(',',@moiscomptable) _finliste");


#################################################
#construction listes des statistiques a afficher
#################################################


#recuperation des paras de tri
my $antri=param("antri") ? param("antri") : $ancourscomptable;

my $moistri=param("moistri") ? param("moistri") : $all;
my $typeantri = param("typeantri") ? param("typeantri") : "comptable";

$para{"antri"} = $antri;
$para{"moistri"} =$moistri;
$para{"typeantri"} = $typeantri;
	



my $nb=param("nbligtri")?param("nbligtri"):$nbligstat;
my ($orderpcd, $ordersuiv)=(param("pcdt"),param("suiv"));
my $chaine = param('chaine');
#&debug("para ancien = $chaine\n para nouveau = $ch");

#dec var 
my $lig = '';
my @tablecond = ();
my $moyenne=0;
my $inddeb = 0;


&debug("debut contruction liste dates");
#tri sur un mois et une annes exacte
if($antri ne $all && $moistri ne $all){	
	if(&compte("montant","banque","mois='$hashmonth{$moistri}' and annee='$antri'")){
		@tablecond = &listecond($moistri,$antri,$moistri,$antri);
	}
}
#tri sur une annee exacte et tous ses mois
elsif($antri ne $all && $moistri eq $all){
 &debug("tri sur une annee et tous les mois");
 if($typeantri eq "calendaire"){
    &debug("debut tri sur une annee calendaire et tous les mois");
    for(my $z=1;$z<=12;$z++){
		if(&compte("montant","banque","mois='$hashmonth{$z}' and annee='$antri'")){
			@tablecond =(@tablecond, &listecond($z,$antri,$z,$antri));
		}
	}
    &debug("fin tri sur une annee calendaire et tous les mois");
  }
  else{ #tri compatble
    &debug("debut tri sur une annee comptable et tous les mois");
  	foreach my $val (@moiscomptable){
	    &debug("mois = $val");
		my $an = ($val >= $moiscomptable) ? $antri : $antri + 1 ;		
		if(&compte("mois","banque","mois='$hashmonth{$val}' and annee='$an'")){
			@tablecond =(@tablecond, &listecond($val,$an,$val,$an));
		}
	}
    &debug("fin tri sur une annee comptable et tous les mois");
  }
}
#tri sur un mois precis et toutes les annees
elsif($moistri ne $all && $antri eq $all){
	for(my $z=$anmin;$z<=$ancour;$z++){
		if(&compte("montant","banque","mois='$hashmonth{$moistri}' and annee='$z'")){
			#print p "lig=$lig";
			@tablecond=(@tablecond,&listecond($moistri,$z,$moistri,$z));
		}
	}
}		
else{#antri = moistri = all
	if(&compte("montant","banque","mois='$hashmonth{$moismin}' and annee='$anmin'")){
		@tablecond=&listecond($moismin,$anmin,$moiscour,$ancour);
	}
}		

&debug("fin contruction liste dates");

#liste des valeurs mois / mois
&debug("debut construction listes statistiques");
my @table = ();
my $somca= my $somdep = my $sombenef= my $somentrees= my $sombanque = 0;
if(@tablecond){
  for(my $i=0;$i<@tablecond;$i++){
	#print p "salut";
	my %hachcond=%{$tablecond[$i]};
	#print p "mois: $hachcond{\"moislettre\"}";
	my $cond="datefact >= $hachcond{'dateinf'} and datefact < $hachcond{'datesup'}";
	$somca+= (my $ca=sprintf("%.2f",&sum("facture","totHT",$cond)));	
	$somdep +=(my $depense=sprintf("%.2f",&sum("depenses","MontHt",$cond)));
	$sombenef +=(my $benefice=sprintf("%.2f",$ca - $depense));	
	$cond="datereglement >= $hachcond{'dateinf'} and datereglement < $hachcond{'datesup'}";
	$cond.= " and statutfact = 1";
	$somentrees +=(my $entree=sprintf("%.2f",&sum("facture","totHT",$cond)));
	#print p "entree =$entree"; 
	$cond="mois='$hachcond{\"moislettre\"}' and annee='$hachcond{\"an\"}'";
	$sombanque +=(my $banque=sprintf("%.2f",&select_une_lig("montant","banque",$cond)));
	my @rangee=($hachcond{"moislettre"},$hachcond{"an"},$ca,$depense,$benefice,$entree,$banque);
	push(@table,\@rangee);
  }
}
&debug("fin construction listes statistiques");

my $taille = @table;
#recuperer numero dans la liste du 1e elem a afficher, du nb de ligne par ecran
#et du 1er elme et du dernier + 1 dans la liste selon ce qui a ete demande et
#deje vu par l'utilisateur
$nblig = $nbligstat;
($inddeb,$orderpcd,$ordersuiv,$nb)= &getIndDeb($nb,0,$ordersuiv,$orderpcd,$taille,$chaine,$ch);
$para{"nbligtri"} = $nb;

#construction d'un tableau contenant juste les enreg a afficher, formater
my @tabAffich=();
for (my $i=$inddeb;$i < ($inddeb + $nb) &&$i<@table;$i++){			
	my @rangee=@{$table[$i]};	
	push(@tabAffich,\@rangee);
	$rangee[7] = {};
}

###############################
#fabrication listes deroulantes
###############################

#fabrication liste deroulante mois
my %hashmonthtri = ();
tie %hashmonthtri,"Tie::IxHash";
%hashmonthtri = ("tous" => $all,%hashmonth);

#liste annee
my %hashantri;
tie %hashantri,"Tie::IxHash";
%hashantri = ( $all => $all, %$refhashcompt);

&debug("appel fonction ListeStatistiques");
#################################
#affichage liste statistiques
################################
&ListeStatistiques($type,$login,$orderpcd,$ordersuiv,$nb,$taille,\@tabAffich,$somca,
                 $somdep,$sombenef,$somentrees,$moistri,$antri,$typeantri,
                 \%hashmonthtri,\%hashantri,\%para);


