#####
#
# Copyright (C) 2002 UNGI
#
# This file is part of UNGI facturier
#
# UNGI Facturier is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# UNGI Facturier is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#####
#
# Visit us!
#
# http://www.ungi.net
# http://ignu.ungi.org
#
#####
#
# 06/10/2003 : maj_tot Modifi pour prise en compte de la remise 
# (par N.Schmeltz pour Abtey Prod)
#
####

#Util.pm =librairies de fonctions non spcifiques au facturier
#peuvent etre reeutilise par n'importe quel prog

package Util;
use strict;
use Tie::IxHash;
use DBI;
use CGI qw(:standard);
use Conf;
use Time::Local;
use lang::Fr;

BEGIN{
	use Exporter;
	use vars qw($VERSION @ISA @EXPORT @EXPORT_OK %EXPORT_TAGS);
	$VERSION = 1.00;
	@ISA = qw(Exporter);
	@EXPORT= qw ( &verif_utilisateur &getIndDeb &alert
	&sec_calend &calend_sec &date_tri &verif_date
	&cherchecomp &restriction &debug &debugParam
	&liste &init_statfact &max &min &listenum
	&select_lig &select_une_lig &select_pcdt &supp &insert
	&select_pcdtbis &getDatemin
	&maj &calculsumestim &supputilisateur
	&maj_tot &majcomplement &compte &sum
	&calculsum &getHashAffich &getParamHash
	&envoiMail &MakeMail &majbanque &listecond
	&getTempComptable &getUneRelance);
	
}

use vars   @EXPORT;

=head2 debug

Trace les vnements du facturier

=cut

sub debug {
=port-FreeBSD sans trace
   my (@DATE) = ("Janvier","Fvrier", "Mars","Avril", "Mai", "Juin", "Juillet","Aot","Septembre", "Octobre","Novembre","Dcembre");
   my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);
   $year += 1900;
   my $date = (length($mday) > 1)?$mday:"0$mday";
   $date .= " $DATE[$mon] $year:";
   $date .= (length($hour) > 1)?$hour:"0$hour";
   $date .= "h";
   $date .= (length($min) > 1)?$min:"0$min";
   $date .= "mn";
   $date .= (length($sec) > 1)?$sec:"0$sec";
   $date .= "s";
   #############vidage fichier debug pour eviter encombrement

   my ($dev,$ino,$mode,$nlink,$uid,$gid,$rdev,$size,
   $atime,$mtime,$ctime,$blksize,$blocks)
                = stat("/var/log/facturier.log");
   if ( $size >= $LOGSIZE )
       {
        for ( my $i=$MAXLOG;$i>1;$i--)
         {
          unlink "/var/log/facturier$i.log";
          my $j=$i-1;
          rename ("/var/log/facturier$j.log","/var/log/facturier$i.log");
         }
        rename ( "/var/log/facturier.log", "/var/log/facturier1.log" );
       }
   
   #############
   open (DEBUG , ">>/var/log/facturier.log") ||
      &alert ("Probleme d'ouverture du fichier de debug");
   print DEBUG "$date:",@_,"\n";
   close (DEBUG);
=cut
   return;
}




#fonction pour qd pb avec bdd
sub alert{
	my ($mess)=@_;
	print header();
	print start_html();
	print p "$mess";
	print end_html;
	die;
}

#fonction de connnection  la base de donnees
sub InitSql{
    #my @connect = ("dbi:mysql:FACTURIER:ungi58",$USERBDD,$MDPBDD);
	my $dbh=DBI->connect(@connect) or
		&alert("pas de connection car $DBI::errstr et $DBI::err");
	return $dbh;
}


#retourne la valeur max d'un champs d'une table
sub max{		
	my ($table,$champs,$cond)=@_;
	my $dbh = &InitSql();
	my $sql= "select max($champs) from $table";
    if($cond){$sql .= " where $cond";}
    # print p "$sql";
	my $sth=$dbh->prepare($sql) or &alert("impossible de preparer $sql car $DBI::errstr et $DBI::err");
	$sth->execute() or &alert("impossible d'excuter $sql car $DBI::errstr et $DBI::err");
	my $id=$sth->fetchrow_array();
	$sth->finish;
	$dbh->disconnect;
	$id = ($id || 0);
	return $id;
}


#retourne la valeur min d'un champs d'une table
sub min{		
	my ($table,$champs)=@_;	
	my $dbh = &InitSql();
	my $sql = "select min($champs) from $table ";
	my $sth=$dbh->prepare($sql) or &alert("impossible de preparer $sql car $DBI::errstr et $DBI::err");
	$sth->execute() or &alert("impossible d'excuter $sql car $DBI::errstr et $DBI::err");
	my $id=$sth->fetchrow_array();
	$sth->finish;
	$dbh->disconnect;
	$id = ($id || 0);
	return $id;
}

#convertir les secondes en date
sub sec_calend{
	my $date;
	my ($sec, $min, $heure, $mjour, $mois, $an, $sjour, $ajour, $isdst)=
	localtime($_[0]);
	$mois=$mois+1;
	$an=$an + 1900;
	my @date=($mjour,$mois,$an);
	return @date;
}

#convertir la date en secondes
sub calend_sec{
	my ($jour, $mois, $an)=@_;
	$mois=$mois - 1;
	$an-=1900;	
	my $date = timelocal(0,0,0,$jour,$mois,$an);
	return $date;
}

#retourne l'annecomptable en cours et la liste
#des annes existantes(de anmin a ancour)
sub getTempComptable{
	&debug("debut sub getTempComptable");
    #plus petit mois et annee possible
	my ($moismin,$anmin) = @_;
	#mois et annee en cours
	my (undef,$moiscour,$ancour) = &sec_calend(time);
    #print p "moiscour =$moiscour,ancour =$ancour";
	#annee comptabel en cours
    my $ancourscomptable = ($moiscour >= $moiscomptable)?$ancour:$ancour - 1;
    #plus petite annee comptable possible, attention si moismin >= janvier
    #et que mois comptable = sept, et anmin = 2000, alors anmincomptable = 1999
    my $anmincomptable = ($moismin >= $moiscomptable)?$anmin:$anmin - 1;
	#print p "anmincomptable = $anmincomptable";
   &debug("liste des annees comptables : ");
   my %hashancompttri;
   tie %hashancompttri,"Tie::IxHash";   
   for(my $an=$anmincomptable;$an<=$ancour;$an++){
	   $hashancompttri{$an}=$an;
   }
   my $listeancomptable = join (',', sort {$a <=> $b} keys %hashancompttri);
   &debug("fin sub getTempComptable : $listeancomptable");
   return ($ancourscomptable,\%hashancompttri);
}


#verif date, verifie la validite d'une date
#si $dep, ne verifie pas que la date est non sup  date du jour
sub verif_date{
	my ($jour, $mois, $an,$dep)=@_;
	my @tab=localtime;
	my ($jourcour,$moiscour,$ancour)=($tab[3],$tab[4],$tab[5]);
	$ancour+=1900;
	$moiscour+=1;
	if (($mois =~ /[^0-9]/) || ($jour=~ /[^0-9]/) || ($an=~ /[^0-9]/)){
		return 0;
	}
	if (($mois<1) || ($mois>12)){return 0;}	 
	if (($jour<1) || ($jour>31)){return 0;}
	if($an < 2000){return 0;}
	if(!$dep){	  
	   if ($an > $ancour){return 0;}
	   if($an==$ancour && $mois > $moiscour){return 0;}
	   if($an == $ancour && $mois == $moiscour && $jour > $jourcour){return 0;}
	}
	if(($mois==4 || $mois==6 || $mois==9 || $mois==11) && ($jour >30))
		{return 0;}
	if($mois ==2 && $jour > 29){return 0;}
	if(($mois==2 && $jour == 29) && 
	(($an%4 != 0) || ($an%4==0 && $an%100==0 && $an%400!=0)))
		{return 0;}
	return 1;	
}	 

#tri par date renvoi la chaine de requete adequate
sub date_tri{
	my $ok;
	my $ch;

#$an,$mois,$jour= entree par l'utilisateur pour le tri
#$datelib nom du champs date ds la table	
#si $dep, ne fait pas de controle sur date sup  date jour
	my ($an,$mois,$jour, $datelib,$table,$dep)=@_;
	my $sql="select max($datelib), min($datelib) from $table ";
	my $dbh = &InitSql();
	my $sth=$dbh->prepare($sql) or &alert("impossible de preparer $sql car $DBI::errstr et $DBI::err");
	$sth->execute() or &alert("impossible d'executer $sql car $DBI::errstr et $DBI::err");	
	my ($datesecmax,$datesecmin)=$sth->fetchrow_array();
	$sth->finish();
	$dbh->disconnect();
	my @datemax=&sec_calend($datesecmax);
	my $anmax=$datemax[2];
	my @datemin=&sec_calend($datesecmin);
	my $anmin=$datemin[2];
	#print header;
	#print p"anmin= $anmin anmax=$anmax";
	#print p $datelib;
	if($jour){
		if ($an && $mois){
			if($ok=&verif_date($jour, $mois, $an,$dep)){
				my $date=&calend_sec($jour, $mois, $an);
				$ch= " and $datelib = '$date' ";
				return $ch;
			}
		}
		elsif ($mois){
				for (my $antri=$anmin; $antri <= $anmax;$antri++){
				#print p "$antri";
				if ($ok=&verif_date($jour, $mois, $antri,$dep)){
					my($j,$m,$a)=($jour, $mois, $antri);
					my $date=&calend_sec($j,$m,$a);
					if(!$ch){$ch=" and ($datelib = $date ";}
					else {$ch.= " or $datelib = $date ";}
				}
			}	
			if ($ch){$ch.= " ) ";}
			return $ch;
		}
		elsif ($an){
			for(my $moistri=1;$moistri<=12; $moistri++){
					if ($ok=&verif_date($jour, $moistri, $an,$dep)){
						my($j,$m,$a)=($jour, $moistri, $an);
						my $date=&calend_sec($j,$m,$a);
						if(!$ch){$ch=" and ($datelib = $date ";}
						else {$ch.= " or $datelib = $date ";}
					}
				}	
			if ($ch){$ch.= " ) ";}
			return $ch;	
			}
		else{#seulement le jour
				for (my $antri=$anmin; $antri <= $anmax;$antri++){
				#print p"$antri";
				for(my $moistri=1;$moistri<=12; $moistri++){
					#print p " $antri $moistri $jour";
					if ($ok=&verif_date($jour, $moistri, $antri,$dep)){
						#print p " $antri $moistri $jour";
						my($j,$m,$a)=($jour, $moistri, $antri);
						my $date=&calend_sec($j,$m,$a);
						#print p "$date";
						if(!$ch){$ch=" and ($datelib = $date ";}
						else {$ch.= " or $datelib = $date ";}
					}
				}
			}	
			if ($ch){$ch.= " ) ";}
			return $ch;	
		}		
	}
	elsif($mois){
		if($an){
			for(my $jourtri=1; $jourtri <= 31;$jourtri++){
				if ($ok=&verif_date($jourtri, $mois, $an,$dep)){
					my($j,$m,$a)=($jourtri, $mois, $an);
					my $date=&calend_sec($j,$m,$a);
					if(!$ch){$ch=" and ($datelib = $date ";}
					else {$ch.= " or $datelib = $date ";}
					}
			
			}
			if ($ch){$ch.= " ) ";}
			return $ch;	
		}
		else{#seulement le mois
			for (my $antri=$anmin; $antri <= $anmax;$antri++){
				for(my $jourtri=1; $jourtri <= 31;$jourtri++){
					if ($ok=&verif_date($jourtri, $mois, $antri,$dep)){
						my($j,$m,$a)=($jourtri, $mois, $antri);
						my $date=&calend_sec($j,$m,$a);
						if(!$ch){$ch=" and ($datelib = $date ";}
						else {$ch.= " or $datelib = $date ";}
						}
				}
			}
			if ($ch){$ch.= " ) ";}
			return $ch;	
			}
			
		}
	elsif ($an){#seulement l'annee
		if($ok=&verif_date(1,1,$an,$dep)){
			my $date1=&calend_sec(1,1,$an);
			my $date2=&calend_sec(1,1,$an + 1);
			$ch= " and $datelib between  $date1 and $date2 ";						
			}
			return $ch;
		}	
	return $ch;		
					
}

=head2 getParamHash

traite les para en entree :substitution ' et "", 
supp des multiples \s
affiche dans debug les para reus avant et pares trt
construit le hacahge des parametres reus

=cut

sub getParamHash{
    &debug("debut sub getParamHash");
	my (@param) = @_;
    my $listeavant = my $listeapres = '';
    foreach my $para (@param){

	  if(param($para)){
		my @val=param($para);
		$listeavant .= $para."=".join(',',@val)."\n";
		foreach my $val(@val){		   		   		  
		   $val =~ s/^\s+//g;
		   $val =~ s/\s+$//;
		   $val =~ s/\s+/ /g;
		   $val =~ s/(?<!\\)('|")/\\$1/g;
		}
		param($para => @val);
	    $listeapres .= $para."=".join(',',@val)."\n";
	  }
    }
	#&debug("para avant trt\n",$listeavant);
    #&debug("para apres trt\n",$listeapres);
    my %para = ();
    my $ch='';
    foreach my $para (@param){	
	  if($para =~ /tri$/ && param($para)){
		 $para{$para} = param($para);
		 $ch .="$para=$para{$para}&";
	  }
    }
    $ch =~ s/&$//;
    return (\%para,$ch);
}		

sub cherchecomp{
	my $numfact=$_[0];
	my $retour=0;
	#$listechamps,$table,$cond, $order)
	my $cond="numfact=$numfact && complement <>0";
	my @liste=&listenum('ligfact','lig_facture',$cond,'ligfact');
	if(@liste){$retour=1;}
	return $retour;
}

#ramene une liste de valeur d'une base de donnee
sub listenum{
	#print header,start_html;
	my ($listechamps,$table,$cond, $order)=@_;
	my @tab=();
	my $dbh = &InitSql();
	my $sql= "select $listechamps from $table where $cond order by $order";
	#print p $sql;
	my $sth=$dbh->prepare($sql) or &alert("impossible de preparer $sql car $DBI::errstr et $DBI::err");
	$sth->execute() or &alert("impossible d'executer sql=$sql car $DBI::errstr et $DBI::err");
	
	#mettre ds un tableau toutes les lignes selectionnes
	while(my ($rangee)=$sth->fetchrow_array()){		
		push(@tab,$rangee);		
		}
	#print p "@tab";
	$dbh->disconnect();	
	return (@tab);
	}		
	
=pod

sub verif_utilisateur
verifie la validite de la connection, retourne le role de l'utilisateur
cad userrole (type utilisateur)

=cut
 	
sub verif_utilisateur{
	my ($login,$passwd)=@_;
	my $type = '';
	if($login){
		my ($usertype,$userpasswd)=
		&select_une_lig('userrole, userpasswd','utilisateur',"userlogin = '$login'");
		if($usertype){#ramene un enreg
			my $salt = substr($passwd, 0, 2);
			$passwd = crypt($passwd, $salt);
			if($passwd eq $userpasswd){
				$type=$usertype;
			}#les donnes entrees sont correct
		}
	}
	return $type;
}

=pod

sub getIndDeb, prend en argument:
    $nb=nb de lignes a afficher par acran, demander par l'utilisateur
    $idmod = PK d'une ligne a surligner
    $ordersuiv = numaro dans la liste pracedente du dernier elem + 1 (<>PK)
    $orderpc = numaro dans la liste precedente du 1er elem(<>PK)
    $taille = taille du tableau
  retourne :
    $inddeb = indice dans la liste du 1er elem a afficher
    $nb=nb de ligneseffectit  a afficher par acran 
    $ordersuiv = numaro dans la liste actuelle du dernier elem + 1 
    $orderpc = numaro dans la liste actuelle du 1er elem
    $chaine = les arg du tri precedents, sert a calculer $nb
    $ch = les arg du tri actuels
    
=cut

sub getIndDeb{
	my ($nb,$idmod,$ordersuiv,$orderpcd,$taille,$chaine,$ch) = @_;
	my $inddeb = 0;
=pod
	if($chaine && $nb < $nblig){
	   $nb = &getNbLigne($nb,$chaine,$ch);
	   #print p "nb = $nb";	   
	}
=cut
	#nb de ligne a afficher par cran
	if( $nb <= 0 || $nb =~ /\D/ || $nb >= $taille){ $nb=$taille ;}
	#numaro dans la liste du 1er element afficher
	if(defined(param("suivant.x"))){
		$inddeb=$ordersuiv  || 0 ;
		if (($inddeb + $nb) > $taille){
			$inddeb = $taille - $nb;
		}
	}
	if(defined(param("precedent.x"))){$inddeb = $orderpcd - $nb;}
	#si on appelle la liste des factures de la barre de navigation,
	#qui par defaur affiche sur la derniere facture, pour que la facture
	#surligne soit prise en compte	
	if(defined(param("dernier.x")) && !$idmod){$inddeb=$taille - $nb;}
	if ($inddeb<0){$inddeb=0};
	#le 1er et le dernier elem + 1 de la liste actuelle
	$ordersuiv = $inddeb + $nb;
	$orderpcd = $inddeb ;	
	return($inddeb,$orderpcd,$ordersuiv,$nb);
}

=head2  getNbLigne

retourne le nb de ligne a afficher par ecran selon que les arguements
du tri a lancer ($ch) sont egaux ou pas a ceux du tri precedents
sont identiques ou pas au tri 

=cut

sub getNbLigne{
	my ($nb,$chaine,$ch) = @_;
	my %chaine = ();
	my @chaine = split(/&/,$chaine);
	foreach my $val (@chaine){
		my @val = split(/=/,$val);
		$chaine{$val[0]} = $val[1];			
	}
	my %ch = ();
	my @ch = split(/&/,$ch);	
	foreach my $val (@ch){
		my @val = split(/=/,$val);
		$ch{$val[0]} = $val[1];			
	}
	delete $ch{"nbligtri"};
	delete $chaine{"nbligtri"};
	foreach my $clef (keys %chaine){
		if(!exists $ch{$clef} || $ch{$clef} ne $chaine{$clef}){
			$nb = $nblig;last;
		}
	}
	foreach my $clef (keys %ch){
		if(!exists $chaine{$clef} || $chaine{$clef} ne $ch{$clef}){
			$nb = $nblig;last;
		}
	} 
	return $nb;
}


#ramene le num dans l'ordre de tri de celui qui precede idmod
sub select_pcdt{
	my ($listechamps,$table,$cond,$order,$supp)= @_;
	my $idmod=0;my $id;
	#print "supp = $supp";
	my $sql= "select $listechamps from $table where $cond order by $order";
	#print p $sql;
	my $dbh = &InitSql();
	my $sth=$dbh->prepare($sql) or &alert("impossible de preparer $sql car $DBI::errstr et $DBI::err");
	$sth->execute or &alert("impossible de preparer $sql car $DBI::errstr et $DBI::err");
	while((($id)=$sth->fetchrow_array()) && ($id!=$supp)){
		$idmod=$id;
		#print "id=$id";
		}
	$sth->finish();
	$dbh->disconnect();
	return $idmod;
}

#amene le num  de celui qui precede idmod mais seulement pour ordre de tri sur identifiant
sub select_pcdtbis{
	my ($listechamps,$table,$cond,$order,$supp)= @_;
	my $idmod=0;my $id;
	#print "supp = $supp";
	my $sql= "select $listechamps from $table where $cond order by $order";
	#print p $sql;
	my $dbh = &InitSql();
	my $sth=$dbh->prepare($sql) or &alert("impossible de preparer $sql car $DBI::errstr et $DBI::err");
	$sth->execute or &alert("impossible de preparer $sql car $DBI::errstr et $DBI::err");
	while((($id)=$sth->fetchrow_array()) && ($id < $supp)){
		$idmod=$id;
		#print "id=$id";
		}
	$sth->finish();
	$dbh->disconnect();
	return $idmod;
}


#pour maj totaux ds facture
sub maj_tot{
	my $numfact=$_[0];
	my ($totHT, $totHTremise, $remise, $totTTC);
	my $fraisdeplt;
	my $dbh = &InitSql();
	
	# Rcupration de la remise de la facture
	my $sql = "SELECT remise FROM facture WHERE numfact = $numfact";
	my $sth = $dbh->prepare($sql) or &alert("Impossible de prparer car $DBI:: errstr et $DBI::err");
	$sth->execute() or &alert("impossible d'executer car $DBI::errstr et $DBI::err");
	($remise) = $sth->fetchrow_array();
	$sth->finish;

	# Calcul des totaux
	$sql =" select sum(qtefacture*prixHT), ";
	$sql.= " sum(qtefacture*prixHT*(1 - $remise/100)*(1 + tauxTVA)) from lig_facture ";
	$sql.= " where numfact = $numfact ";
	$sql.= "group by numfact";
	$sth=$dbh->prepare($sql) or &alert("impossible de preparer car $DBI::errstr et $DBI::err");
	$sth->execute() or &alert("impossible d'executer car $DBI::errstr et $DBI::err");
	($totHT, $totTTC)=$sth->fetchrow_array();
	$sth->finish();
	if(!$totHT){$totHT=0;}
	if(!$totTTC){$totTTC=0;}
	$totHTremise = $totHT * (1 - $remise/100);
	
	$sql = "select fraisdeplt from facture where  numfact = $numfact ";
	$sth=$dbh->prepare($sql) or &alert("impossible de preparer car $DBI::errstr et $DBI::err");
	$sth->execute() or &alert("impossible d'executer car $DBI::errstr et $DBI::err");
	$fraisdeplt = $sth->fetchrow_array();
	$sth->finish();
	$totTTC+=$fraisdeplt;
	$sql = "update facture set totHT=$totHT, totTTC=$totTTC, totHTremise=$totHTremise";
	$sql .= " where numfact = $numfact ";
	$sth=$dbh->prepare($sql) or &alert("impossible de preparer car $DBI::errstr et $DBI::err");
	$sth->execute() or &alert("impossible d'executer car $DBI::errstr et $DBI::err");;
	$dbh->disconnect;
}

#maj complement
sub majcomplement{
	my $ligfact=$_[0];
	#$listechamps,$table,$cond
	my ($complement)=&select_une_lig('complement','lig_facture',"ligfact=$ligfact");
	#$table,$champs,$cond
	if($complement){
		my $sum=&sum("lig_facture","qtefacture","complement=$complement");
		if($sum >=1){
			#$champs,$idquestion, $refhach,$table
			&majquest("complement","$complement",{'complement'=> '0'},'lig_facture');
		}
	}
	return;
}
	

#insertion d'une ligne dans une table
sub insert{
    &debug("debut fonction insert");
    my ($liste_val,$liste_champs,$table)=@_;
	my $dbh = &InitSql();
	my $sql= "insert into $table $liste_champs values $liste_val";
	#print "sql = $sql";
	&debug("sql = $sql");
	my $sth=$dbh->prepare($sql) or &alert("impossible de preparer $sql car $DBI::errstr et $DBI::err");
	$sth->execute() or &alert("impossible d'executer $sql car $DBI::errstr et $DBI::err");
	$sth->finish;
	$dbh->disconnect;
    &debug("fin fonction insert");
	return;
}



#fait un update mais prend comme arg une condition  
sub maj{
	my ($cond, $refhach,$table )=@_;
	my %hach = %$refhach;
	my ($clef,$val);
	my $sql = "update $table set ";
	foreach $clef (keys %hach){
		$sql.= " $clef='$hach{$clef}',";
		}
	$sql =~ s/\,$/ /;	
	$sql.= " where $cond ";
	
	#print header,start_html;
	#print p $sql;
	my $dbh = &InitSql();
	my $sth=$dbh->prepare($sql) or &alert("impossible de preparer $sql car $DBI::errstr et $DBI::err");
	#print p $sql;
	$sth->execute() or &alert("impossible d'executer $sql car $DBI::errstr et $DBI::err"); 
	#print p $sql;
	$dbh->disconnect();
	return;
} 		

#ramene les lignes d'une requete ds un tableau
sub select_lig{
	#print header,start_html;
	my ($listechamps,$table,$cond, $order,$idmod)=@_;
	my $i;
	my @tab; my $ordersuiv;
	#$idmod=$idmod?$idmod:0;
	my $dbh = &InitSql();
	#my $dbh=DBI->connect($CONNECTBDD,$USERBDD, $MDPBDD) or &alert("pas de connection car $DBI::errstr et $DBI::err");
	my $sql= "select $listechamps from $table where $cond order by $order";
	#print p "$sql\n";
#=pod
	my $sth=$dbh->prepare($sql) or &alert("impmossible de preparer $sql car $DBI::errstr et $DBI::err");
	$sth->execute() or &alert("impossible d'executer $sql car $DBI::errstr et $DBI::err");
	$i=0;
	#mettre ds un tableau toutes les lignes selectionnes
	while(my @rangee=$sth->fetchrow_array()){
		if(($rangee[0] =~ /^[0-9]+$/)  && ($rangee[0] == $idmod)){$ordersuiv=$i;}
		 #print p "rangee = @rangee";
		push(@tab,\@rangee);
		$i++;		
	}
	
	$dbh->disconnect();	
	return (\@tab,$ordersuiv);
#=cut
}
	


#selectionner une ligne d'une table
sub select_une_lig{
    &debug("debut select_une_lig");
	my ($listechamps,$table,$cond)= @_;
	my @tab;
	my $sql= "select $listechamps from $table where $cond ";
	#print p $sql;
	my $dbh = &InitSql();
	my $sth=$dbh->prepare($sql) or &alert("impossible de preparer $sql car $DBI::errstr et $DBI::err");
	$sth->execute or &alert("impossible d'executer $sql car $DBI::errstr et $DBI::err");
	@tab=$sth->fetchrow_array();
	$sth->finish();
	$dbh->disconnect();
	&debug("fin select_une_lig");
	return @tab;
}

#pour supprimer des lignes
sub supp{
    &debug("debut supp");
	my ($cond,$table) = @_;
	open (TMP, ">/tmp/logsup");
	print TMP "condition : $cond\n";
	close (TMP);
	my $dbh = &InitSql();
	my $sql = "delete from $table ";
	if($cond){$sql .= " where $cond";}
	my $sth=$dbh->prepare($sql)or &alert("impossible de preparer $sql car $DBI::errstr et $DBI::err");
	$sth->execute() or &alert("impossible d'executer $sql car $DBI::errstr et $DBI::err");
	$sth->finish;
	$dbh->disconnect;
    &debug("fin supp");
	return;
}
	


=head2 sub restriction

calcul la permission ou non d'afficher une ligne ou pas
renvoie 1 si on affiche, 0 sinon

=cut

sub restriction {
	my ($type, $acc) = @_;	
	if ($acc =~ /Restricted-to/) {
		# Le fichier est ACCESSIBLE UNIQUEMENT aux utilisateurs mentionnes.
		if (($acc =~ /\s+$type\s+/) or ($acc =~ /\s+anybody\s+/)) {
			# Le type (commercial, admin...) est mentionne: OK
			# Ou le fichier n'est pas restreint (anybody)
			return 1;
		} else {
			return 0;
		}
	} elsif ($acc =~ /Forbidden-to/) {
		# Le fichier est INTERDIT aux utilisateurs mentionnes.
		if (($acc =~ /\s+$type\s+/) or ($acc =~ /\s+everybody\s+/)) {
			# Le type (commercial, admin...) est mentionne: 
			# ACCESS INTERDIT
			# Ou le fichier est interdit a tout le monde (everybody)
			return 0;
		} else {
			return 1;
		}
	} else {
		# Pas de controle d'acces
		return 1;
	}
}

#retour d'une liste , avec comme clef $clef et
#affichage de $listechamps
sub liste{
	my ($log,@nom,%tab);
	my ($table,$clef,$liste_champs,$cond, $order)=@_;
	tie %tab,"Tie::IxHash";
	my $sql=" select distinct $clef,$liste_champs from $table ";
	if($cond){
		$sql.= "where $cond ";
		}
	$sql .= " order by $order ";	
	#print p "sql = $sql";
    my $dbh = &InitSql();
	my $sth=$dbh->prepare($sql) or &alert("impossible de preparer $sql car $DBI::errstr et $DBI::err");
	$sth->execute() or &alert("impossible d'executer $sql car $DBI::errstr et $DBI::err");
	#print header,start_html;
	#print p "$sql";

	while( ($log, @nom)=$sth->fetchrow_array()){
		my $nom=join(" - ",@nom);
		$tab{$log}=$nom;
	}			 	
	$sth->finish;
	$dbh->disconnect;

	return %tab;

}


#initialiser un tableau de hachage a partir d'un fic de conf
sub init_statfact{
	my $fich=$_[0];
	my (%typeuti,$clefuti, $uti);
	open(USER,$fich) || die "ouv impo $! $fich";
	while($clefuti = <USER>){
			chomp($clefuti);
				$uti = <USER>;
				chomp($uti);
				$typeuti{$clefuti}=$uti;
			}
			close(USER);
			return %typeuti;
}

	
#caluler une somme dans un tableau	
sub calculsum{
	my ($reftab,$indice)=@_;
	my $sum = 0;
	my @tab=@$reftab;
	for (my $z=0;$z<@tab;$z++){
		my @rangee=@{$tab[$z]};
		$sum+=$rangee[$indice];		
		}	
	return $sum;
}

=pod

sub getHashAffich = retourne un hach de variable format contenant seulement
les formats que l'utilisateur a la droit de voir

=cut

sub getHashAffich{
    &debug("debut sub getHashAffich");
	my ($refligne,$type)=@_;
	my %ligne;
	tie %ligne,"Tie::IxHash";
	%ligne=%$refligne;
	
	my %ligneretour=();
	tie %ligneretour,"Tie::IxHash";
	foreach my $clef (keys %ligne){		
		my @buff=split(/\n/,$ligne{$clef});
		#on passe $buff[1], car $buff[0] est une ligne vide
		#puisque les var sont de la forme $var =q|
		#ccccc				
		if(&restriction($type,$buff[1])){
			$ligneretour{$clef} = $ligne{$clef};
		}
	}
	&debug("fin sub getHashAffich");	
	return %ligneretour;
}


#calcul somme d'une liste enreg
sub sum{
    &debug("debut fonction sum");
	my ($table,$champs,$cond)=@_;
	my $dbh = &InitSql();
	#print p "select sum($champs) from $table where $cond";
	my $sql = "select sum($champs) from $table where $cond";
	&debug("sql = $sql");
	my $sth=$dbh->prepare($sql) or &alert("impossible de preparer $sql car $DBI::errstr et $DBI::err");
	$sth->execute() or &alert("impossible d'executer $sql car $DBI::errstr et $DBI::err");
	my $id=$sth->fetchrow_array() || 0;
    #my $id=$sth->fetchrow_array() ;
	$sth->finish;
	$dbh->disconnect;
    &debug("fin fonction sum");
	return $id;
}

#pour envoyer un mail lors de la creation d'un cde 
sub envoiMail{  
  my ($mail,$messmail) =@_;
  #encoder les car > 128 
  $messmail =~ s/(.) && (chr($1) >=128)/\\$1/g; 
  $messmail =~ s/\\('|")/$1/g; 
  open(MAIL,"|/usr/lib/sendmail  $mail");
  print MAIL  $messmail;
  close(MAIL);
  return;
}

#fabrique le messahe mail a envoyer en cas de nouvelle commande
sub MakeMail{
	my ($commercial,$nomcli,$jourf,$moisf,$anf,$chefprojet,$prix,$libelle)=@_;	
	my $messmail =  "from: $commercial\n";
    $messmail .=  "to: $mail\n"; 
    $messmail .=  "subject: Nouvelle commande!\n\n";
    $messmail .= "Nous avons sign avec $nomcli, le $jourf/$moisf/$anf\n";
    $messmail .= "pour $libelle \n";
    if ( $chefprojet ne "" ) {$messmail .=  "Merci $chefprojet\n";}
    if($prix){$messmail .= "Le montant est de $prix euro\n\n--\n$commercial";}
    return $messmail;	
}

=head2 getDatemin

retourne le plus petit moi et la plus petite annee 
des depenses/factures

=cut

sub getDatemin{
  my $datemin = my $dateminfact = my $datemindep=0;
  if(&compte("numfact","facture","numfact >= 1")){
	$dateminfact=&min("facture","datefact");
  }

  if(&compte("depenseid","depenses","depenseid >= 1")){
	$datemindep=&min("depenses","datefact");
  }
 #datemin = plus petite date valide de depenses ou facture
 #$datemin=($dateminfact &&  $dateminfact <= $datemindep)?$dateminfact:$datemindep;
 if($dateminfact){$datemin = $dateminfact;}
 elsif($datemindep){$datemin = $datemindep;}
 if($dateminfact && $datemindep){$datemin = ($dateminfact < $datemindep)?$dateminfact : $datemindep;}
 
 my $moismin = my $anmin = 0;
 if($datemin){ (undef,$moismin,$anmin) = &sec_calend($datemin);}
 &debug("datemin = mois : $moismin _ an =  $anmin ");
 return ($moismin,$anmin);
}


=head2 majbanque

maj de la table banque. vide la table et la remet a jour
a partir de la datemin(dep/fact) et jusqu'a dateencour

=cut

sub majbanque{
	#$listechamps,$table,$cond
	&debug("debut sub majbanque");
	#vide la table banque toujours
	&supp("","banque");
	#recup moismin et anmin
	my($moismin,$anmin) = &getDatemin();
	#recup moisen cour et ancour
	my(undef,$moiscour,$ancour)=&sec_calend(time);
	#recupere les hachages de date corresponadant
#=pod
	if($moismin){
		my @tablecond = &listecond($moismin,$anmin,$moiscour,$ancour);
	    for(my $i=0;$i<@tablecond;$i++){
			my %hachcond=%{$tablecond[$i]};
			my $moispcdt=($hachcond{"mois"}==1)?12:($hachcond{"mois"} -1);
			my $moispcdtlettre=$hashmonth{$moispcdt};
			my $anpcdt=($hachcond{"mois"}==1)?$hachcond{"an"} - 1:$hachcond{"an"};
            my $banqpcdt = $constbank;
			if(&compte ("mois","banque","mois='$moispcdtlettre' and annee='$anpcdt'")){
			  ($banqpcdt)=&select_une_lig("montant","banque","mois='$moispcdtlettre' and annee='$anpcdt'");
			}

			my $cond="datefact >= $hachcond{'dateinf'} and datefact < $hachcond{'datesup'}";
			my $depense=&sum("depenses","MontHt",$cond) || 0;

			$cond="datereglement >= $hachcond{'dateinf'} and datereglement < $hachcond{'datesup'}";
			$cond.= " and statutfact = 1";
			my $entree=&sum("facture","totHT",$cond) || 0;
			my $banque=$banqpcdt + $entree - $depense;

			my $moislettre=$hachcond{"moislettre"};
			&debug(" mois = $moislettre, depenses = $depense, entree =$entree, banque = $banque");

			&insert("('$moislettre','$hachcond{\"an\"}',$banque)", "(mois,annee,montant)","banque");
		}
		&debug("fin sub majbanque");
	}
	return;
#=cut
}
	

=head2 listecond
ramene un tableau de hachage, du mois et de l'anne min 
au mois et a l'anne max, ces 4 elem sont transmis en argument
chaque hach est ainsi constitue ainsi:
	$hach{"moislettre"} = equivalent litteral du mois: janvier, mars,...
	$hach{"mois"} = mois en num, janvier = 1 et dec = 12
	$hach{"an"} = annee su 4 chiffres, par ex 2000, 2001,...
	$hach{"dateinf"} = equiv en sec du 1 mois an
    $hach{"dateinf"} = equiv en sec du 1 mois + 1 an
	un mois d'ecart entre dateinf et datesup

=cut

sub listecond{
    &debug("debut sub listecond");
	my ($moismin,$anmin,$moiscour,$ancour)=@_;	
	my @tabcond;	
	for(my $an=$anmin;$an<=$ancour;$an++){
		for(my $mois=1;$mois<=12;$mois++){
			if(!(($an==$anmin && $mois<$moismin) || ($an==$ancour && $mois>$moiscour))){				
				my %hachdate=("moislettre" => $hashmonth{$mois},"an" =>$an);
				#print p "mois= $hachdate{\"mois\"}";
				my $dateinf=&calend_sec(1, $mois, $an);
				my $datesup;
				if($mois < 12){
					$datesup=&calend_sec(1,$mois + 1, $an);
					}
				else{$datesup=&calend_sec(1,1, $an + 1);}						
				$hachdate{"dateinf"}=$dateinf ;
				$hachdate{"datesup"}=$datesup ;
				$hachdate{"mois"} = $mois;				
				push(@tabcond,\%hachdate);
				}
			}
		}
    &debug("fin sub listecond");
	return @tabcond;		
}


#caluler une somme dans un tableau	
sub calculsumestim{
	my ($reftab,$indice,$indicepourc)=@_;
	my $sum = 0;
	my @tab=@$reftab;
	for (my $z=0;$z<@tab;$z++){
		my @rangee=@{$tab[$z]};
		$sum+=$rangee[$indice]*$rangee[$indicepourc] /100;		
	}	
	return $sum;
}

sub supputilisateur{
	my ($supp) = @_;
	#selectionner le role
	#$listechamps,$table,$cond
	my ($role,$nomcomplet) = &select_une_lig("userrole,nomcomplet",'utilisateur',"userid = $supp");
	if($role =~ /^(commercial|chefprojet)$/){
		#$cond, $refhach,$table
		$nomcomplet =~ s/(?<!\\)('|")/\\$1/g; 
		if($role =~ /commercial/){
		   &maj("commercial = '$nomcomplet'",{$role => $nobody},'commande');
		   &maj("commercial = '$nomcomplet'",{$role => $nobody},'propal');		   
		}
		elsif($role =~ /chefprojet/){
		   &maj("chefprojet = '$nomcomplet'",{$role => $nobody},'commande');
		   &maj("chefprojet = '$nomcomplet'",{$role => $nobody},'propal');		   
		}	
	}
				
	&supp("userid = $supp",'utilisateur');
	return;
}

#pour compter des enreg
sub compte{
    &debug("debut sub compte");
	my ($count,$table,$cond)=@_;
	my $dbh = &InitSql();
	my $sql = "select count($count) from $table where $cond";
	my $sth=$dbh->prepare($sql) or &alert("impossible de preparer $sql car $DBI::errstr et $DBI::err");
	$sth->execute() or &alert("impossible d'executer $sql car $DBI::errstr et $DBI::err");
	my $id=$sth->fetchrow_array();
    $sth->finish;
    $dbh->disconnect;
    &debug("fin sub compte");
	return $id;
}

sub getUneRelance{
	my ($numfact) = @_;
	my $listechamps =  "clientnom, datefact, totTTC,clientrue1, clientville,dateecheance, ";
	$listechamps .= " clientcp, numfact, statutfact, ";
	$listechamps .= "  clientnom2, clientrue2, clienttitre, clientpays,fax";
	my $cond="facture.clientidfact = client.clientid  and numfact = $numfact ";
	my $table="facture, client "; 
	my @facture = &select_une_lig($listechamps,$table,$cond);
	#liste des relances existantes
	my @listerelance = &listenum("daterelance","relance","numfact = $numfact","daterelance");
	my $compte = @listerelance;
	&debug("numfact = $numfact, nb rel = $compte");
	return(\@facture,\@listerelance);
}

	 					
1;

END{}	
	 
